/*
 * File:   C06l.c   12.09.2009
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>

// Pointers and arrays - dynamicka alokace pameti, malloc(), free()
// Otoc pole

// Function prototypes
void ctiPole2 (int **p_pole, int *delka, int max_delka);
void obratPole (int p[], int delka_pole);
void vypisPole (int p[], int delka_pole);
void vratPole1(int **p_pole);
int nextInt(int *cislo);

int main(int argc, char** argv) {
    #define MAX_DELKA 20
    int *p_pole, n;
    printf(" === C06l.c ===\n\n");
    printf(" Obrat pole - pomoci funkci \n");
    printf(" Dynamicke prideleni (alokace) pameti \n");
    printf(" Predani ukazatele odkazem (ukazatel na ukazatel) \n\n");
    ctiPole2(&p_pole, &n, MAX_DELKA);
    obratPole(p_pole, n);
    vypisPole(p_pole, n);
    vratPole1(&p_pole);
    return (EXIT_SUCCESS);
}// main() END

void ctiPole2 (int **pp_pole, int *delka, int max_delka){
    // Pole je prideleno (alokovano dynamicky - malloc()
    // Ukazatel se bezne predava hodnotou, proto kdyz je treba
    // predat ukazatel odkazem (call by value) pouzijeme
    // ukazatel na ukazatel (tj. **p_pole). Adresa pole
    // pridelena funkci malloc() je pak dostupna i po
    // ukonceni funkce ctiPole2()
    // Pocet prvku pole se predava z funkce odkazem *delka
    int i;
    printf(" Zadejte pocet cisel = ");
    if (!nextInt(delka)) {
        printf("\n Chyba - Zadany udaj neni cele cislo\n\n");
        exit(EXIT_FAILURE);
    }
    if(*delka <1 || *delka > max_delka){
        printf("\n Chyba - pocet cisel = <1,%d> \n\n",MAX_DELKA);
        exit(EXIT_FAILURE);
    }
    // Alokace pameti (prideleni pameti z "heapu")
    if((*pp_pole=(int*)malloc((*delka)*sizeof(int))) == NULL){
        printf("\n Chyba - neni dostatek volne pameti \n\n");
        exit(EXIT_FAILURE);
    }
    printf("\n Zadejte cela cisla (kazde ukoncit ENTER)\n\n");
    for (i = 0; i < *delka; i++) {
        if (!nextInt((*pp_pole)+i)) {
            printf("\n Chyba - Zadany udaj neni cele cislo\n\n");
            exit(EXIT_FAILURE);
        }
    }
}// ctiPole() END

void obratPole (int p[], int delka_pole){
    // Pole p[] se predava odkazem (call by reference)
    int i, x, n_pul;
    n_pul= delka_pole/2;
    for(i=0; i<n_pul; i++ ){
        x = p[i];
        p[i] = p[delka_pole-i-1];
        p[delka_pole-i-1] = x;
    }
}// obratPole() END

void vypisPole (int p[], int delka_pole){
    // Pole p[] se predava odkazem (call by reference)
    int i;
    printf("\n Vypis cisel v obracenem poradi \n\n");
    for(i=0; i<delka_pole; i++){
        printf("pole[%d] = %d \n", i, p[i]);
    }
    printf(" \n");
}// vypisPole() END

void vratPole1(int **p_pole){
    // **p_pole je ukazatel na ukazatel, do metody predana
    // adresa ukazatele je pouzita k nastaveni vlastniho
    // ukazatele na NULL. To pozdeji v programu umozni
    // testovat zda je ukazatel platny nebo neplatny.
    free(*p_pole);   // Dealokace pameti (vraceni pridelene pameti)
    *p_pole = NULL;  // Bezpecnostni opatreni
}// vratPole() END

int nextInt(int *cislo){
    // Stav: odladeno
    // === Bezpecne pro libovolny zadany pocet znaku ===
    // Navratova hodnota:
    // TRUE  - zadano cele cislo
    // FALSE - neplatny vstup
    enum boolean {FALSE,TRUE};
    const int BUF_SIZE = 80;
    char vstup[BUF_SIZE],smeti[BUF_SIZE];
    fgets(vstup,sizeof(vstup),stdin);
    if(sscanf(vstup,"%i%[^\n]",cislo,smeti) != 1)
        return(FALSE); // Input error
    return(TRUE);
}// nextInt() END



