/*
 * File:   C10a.c    06.09.2009
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>

// Union, struktura v unionu (anonymni a pojmenovana)
// Union - prekryta pamet promennych

typedef unsigned char byte;

union {
    int a;
    int b;
}uab;

// Anonymni struktura v unionu
// Pristup: jmeno_unionu.jmeno_prom, napr. u1.a
union {
    struct{
        int a;
        int b;
    };
    struct{
        byte b1;
        byte b2;
        byte b3;
        byte b4;
    };
}u1;

typedef struct{
    int x1;
    int x2;
}Tintx12;

typedef struct{
    byte bx1;
    byte bx2;
    byte bx3;
    byte bx4;
    byte by1;
    byte by2;
    byte by3;
    byte by4;
}Tbytexy14;

// Pojmenovana struktura v unionu
// Pristup: jmeno_unionu.jmeno_struct.jmeno_promenne, napr. u1.intx.x1
union{
    Tintx12 intx;
    Tbytexy14 bytex;
}u2;

union{
   int *px1;
   int *px2;
   int *px3;
}u3;

typedef union{
   int x1;
   int x2;
   int x3;
}Tu4;
Tu4 u4, *pu4;

int main(int argc, char** argv) {
    int x, y;
    byte b;
    printf("=== C10a.c ===\n\n");
    printf(" union, structure \n\n");

    printf(" == union ab == \n\n");
    uab.a = 1;
    printf(" a = %d \n\n", uab.a);
    printf(" b = %d \n\n\n", uab.b);

    printf(" == union u1 == \n\n");
    u1.a = 0x12345678;
    b = u1.b1;
    printf(" x1 = %xh \n\n", u1.a);
    printf(" b4,3,2,1 = %xh %xh  %xh %xh \n\n\n", u1.b4, u1.b3, u1.b2, u1.b1);

    printf(" == union u2 == \n\n");
    u2.intx.x1 = 0x87654321;
    u2.intx.x2 = 0x00AB00CD;
    printf(" x1 = %08Xh \n\n", u2.intx.x1);
    printf(" bx4,3,2,1 = %Xh %Xh %Xh %Xh  \n\n",
            u2.bytex.bx4, u2.bytex.bx3, u2.bytex.bx2, u2.bytex.bx1);
    printf(" x2 = %08Xh \n\n", u2.intx.x2);
    printf(" by4,3,2,1 = %Xh %Xh %Xh %Xh  \n\n\n",
            u2.bytex.by4, u2.bytex.by3, u2.bytex.by2, u2.bytex.by1);

    printf(" == union u3 == \n\n");
    u3.px1 = &x;
    *u3.px1 = 10;
    printf(" x = %d, *px1 = %d, *px2 = %d, px3 = %d \n\n\n",
            x, *u3.px1, *u3.px2, *u3.px3);

    printf(" == union u4 == \n");
    pu4 = &u4;
    u4.x1 = 33;
    pu4->x3 = 55;
    printf("\n u4.x1 = %d, (*pu4).x2 = %d, pu4->x3 = %d \n\n\n",
            u4.x1, (*pu4).x2, pu4->x3);

    printf(" Konec programu \n\n");
    return (EXIT_SUCCESS);
}// main() END

